--[[
    LocalizationLib
    Copyright (C) 2008 Gael Lalire
    Contact: gael.lalire@laposte.net

    LocalizationLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LocalizationLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LocalizationLib.  If not, see <http://www.gnu.org/licenses/>.
--]]

local localizationLib = LibStub:NewLibrary("LocalizationLib-1.0", 1);
if not localizationLib then
  return;
end

-- begin import
local factoryLib = LibStub("FactoryLib-1.0");
local Factory = factoryLib.Factory;
-- end import

local Localization, localization = Factory.CreateSingletonType();
localizationLib.Localization = Localization;
localizationLib.localization = localization;


-- localization:Format("Hello {1}, my name is {2}.", "World", "Lhooq"); will returns "Hello World, my name is Lhooq."
function Localization:Format(expression, ...)
  local argTable = {...};
  local formatedString = "";
  local s = 1;
  local i, e, argNumber = string.find(expression, "{(%d+)}", s);
  while i ~= nil do
    formatedString = formatedString..string.sub(expression, s, i - 1)..argTable[tonumber(argNumber)];
    s = e + 1;
    i, e, argNumber = string.find(expression, "{(%d+)}", s);
  end
  formatedString = formatedString..string.sub(expression, s);
  return formatedString;
end
